#include <string.h>

#define C1 PA4
#define C2 PA5
#define C3 PA6
#define C4 PA7
#define R1 PA0
#define R2 PA1
#define R3 PA2
#define R4 PA3

int col[4] = {C1, C2, C3, C4};
int row[4] = {R1, R2, R3, R4};
char keys[17] = "123A456B789C*0#D";

/*
1 2 3 A
4 5 6 B
7 8 9 C
* 0 # D
*/

void pullLow() {
	for (int i = 0; i < 4; i++) {
		// pulls all pins to low
		PORTA &= ~(1 << col[i]) & ~(1 << row[i]);
		// makes rows output and columns input
		DDRA |= (1 << row[i]);
		DDRA &= ~(1 << col[i]);
	}
}

char readKey() {
	// checks and returns for a keypress
	// or 0 if no key is pressed

	// DDR	0 input
	//		1 output
	int i, j;

	pullLow();

	for (i = 0; i < 4; i++) {
		// pull a row to high
		PORTA |= (1 << row[i]);

		for (j = 0; j < 4; j++) {
			// check column for high
			if (PINA & (1 << col[j])) {
				_delay_ms(1);
				if (PINA & (1 << col[j])) {
					pullLow();
					return keys[4 * i + j];
				}
			}
		}

		//pull the row back to low
		PORTA &= ~(1 << row[i]);
	}
	return 0;

}
